/**
 * @version $Id$
 * @author Thomas Crespin <thomas.crespin@sesamath.net>
 * @copyright Thomas Crespin 2009-2022
 * 
 * ****************************************************************************************************
 * SACoche <http://sacoche.sesamath.net> - Suivi d’Acquisitions de Compétences
 * © Thomas Crespin pour Sésamath <http://www.sesamath.net> - Tous droits réservés.
 * Logiciel placé sous la licence libre Affero GPL 3 <https://www.gnu.org/licenses/agpl-3.0.html>.
 * ****************************************************************************************************
 * 
 * Ce fichier est une partie de SACoche.
 * 
 * SACoche est un logiciel libre ; vous pouvez le redistribuer ou le modifier suivant les termes 
 * de la “GNU Affero General Public License” telle que publiée par la Free Software Foundation :
 * soit la version 3 de cette licence, soit (à votre gré) toute version ultérieure.
 * 
 * SACoche est distribué dans l’espoir qu’il vous sera utile, mais SANS AUCUNE GARANTIE :
 * sans même la garantie implicite de COMMERCIALISABILITÉ ni d’ADÉQUATION À UN OBJECTIF PARTICULIER.
 * Consultez la Licence Publique Générale GNU Affero pour plus de détails.
 * 
 * Vous devriez avoir reçu une copie de la Licence Publique Générale GNU Affero avec SACoche ;
 * si ce n’est pas le cas, consultez : <http://www.gnu.org/licenses/>.
 * 
 */

// Activer le mode strict afin de tendre vers un code rigoureux
'use strict';

// jQuery !
$(document).ready
(
  function()
  {

    // ////////////////////////////////////////////////////////////////////////////////////////////////////
    // creer_identite
    // revoquer_identite
    // ////////////////////////////////////////////////////////////////////////////////////////////////////

    $('#form_instance').on
    (
      'click',
      'button',
      function()
      {
        var button = $(this);
        var action = button.data('action');
        button.prop('disabled',true);
        $('#ajax_msg_identite').attr('class','loader').html('En cours&hellip;');
        $.ajax
        (
          {
            type : 'POST',
            url : 'ajax.php?page='+window.PAGE,
            data : 'csrf='+window.CSRF+'&f_action='+action,
            dataType : 'json',
            error : function(jqXHR, textStatus, errorThrown)
            {
              button.prop('disabled',false);
              $('#ajax_msg_identite').attr('class','alerte').html(afficher_json_message_erreur(jqXHR,textStatus));
              return false;
            },
            success : function(responseJSON)
            {
              button.prop('disabled',false);
              if( responseJSON['statut'] == false )
              {
                $('#ajax_msg_identite').attr('class','alerte').html(responseJSON['value']);
              }
              else if( responseJSON['etat'] == false )
              {
                $('#ajax_msg_identite').attr('class','alerte').html('Échec de la demande !');
              }
              else
              {
                $('#ajax_msg_identite').removeAttr('class').html('');
                var objet_tds = $('#tr_identite').find('td');
                objet_tds.eq(0).hideshow( action == 'creer_identite' );
                objet_tds.eq(1).hideshow( action == 'revoquer_identite' );
                objet_tds.eq(2).hideshow( action == 'creer_identite' );
                objet_tds.eq(3).hideshow( action == 'revoquer_identite' );
                $('#form_services').hideshow( action == 'creer_identite' );
              }
            }
          }
        );
      }
    );

    // ////////////////////////////////////////////////////////////////////////////////////////////////////
    // souscrire_api
    // resilier_api
    // souscrire_service
    // activer_service
    // desactiver_service
    // ////////////////////////////////////////////////////////////////////////////////////////////////////

    $('#form_services').on
    (
      'click',
      'button',
      function()
      {
        var button = $(this);
        var action = button.data('action');
        var td     = button.parent();
        var tr     = td.parent();
        var api    = tr.data('api');
        $('#form_services button').prop('disabled',true);
        $('#ajax_msg_services').attr('class','loader').html('En cours&hellip;');
        $.ajax
        (
          {
            type : 'POST',
            url : 'ajax.php?page='+window.PAGE,
            data : 'csrf='+window.CSRF+'&f_action='+action+'&f_api='+api,
            dataType : 'json',
            error : function(jqXHR, textStatus, errorThrown)
            {
              $('#form_services button').prop('disabled',false);
              $('#ajax_msg_services').attr('class','alerte').html(afficher_json_message_erreur(jqXHR,textStatus));
              return false;
            },
            success : function(responseJSON)
            {
              $('#form_services button').prop('disabled',false);
              if( responseJSON['statut'] == false )
              {
                $('#ajax_msg_services').attr('class','alerte').html(responseJSON['value']);
              }
              else if( ( responseJSON['etat'] == false ) && ( ( action == 'souscrire_api' ) || ( action == 'resilier_api' ) ) )
              {
                $('#ajax_msg_services').attr('class','alerte').html('Échec de la demande !');
              }
              else
              {
                $('#ajax_msg_services').removeAttr('class').html('');
                var objet_tds = tr.find('td');
                if( action == 'souscrire_api' )
                {
                  objet_tds.eq(1).replaceWith('<td class="bv">Oui <button data-action="resilier_api" type="button" class="annuler">Supprimer</button></td>');
                  objet_tds.eq(2).show();
                }
                else if( action == 'resilier_api' )
                {
                  objet_tds.eq(1).replaceWith('<td class="br">Non <button data-action="souscrire_api" type="button" class="ajouter">Souscrire</button></td>');
                  objet_tds.eq(2).hide();
                }
                else if( responseJSON['etat'] == true )
                {
                  objet_tds.eq(2).replaceWith('<td class="bv">Oui <button data-action="desactiver_service" type="button" class="annuler">Désactiver</button></td>');
                }
                else
                {
                  objet_tds.eq(2).replaceWith('<td class="br">Non <button data-action="activer_service" type="button" class="ajouter">Activer</button></td>');
                }
              }
            }
          }
        );
      }
    );

  }
);
